Description: Make Berusky2 compile cleanly with no warnings
 Berusky2 used to generate a *lot* of warnings when compiled. Some of
 these were not too serious, but some seemed like they could possibly
 allow buffer overflows. This patch likely fixes many potential
 crashes as well.
Author: Asher Gordon <AsDaGo@posteo.net>
Bug-Debian: TODO
Reviewed-by: TODO
Last-Update: 2020-01-12
---
This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
Index: berusky2/src/adas/adas.c
===================================================================
--- berusky2.orig/src/adas/adas.c
+++ berusky2/src/adas/adas.c
@@ -214,7 +214,7 @@ void adas_Init(ADAS_INIT_DATA * p_adas_d
 
   memcpy(&ADAS_data, p_adas_data, sizeof(ADAS_INIT_DATA));
 
-  p_Device = alcOpenDevice((ALCubyte *) p_adas_data->Implementation);
+  p_Device = alcOpenDevice(p_adas_data->Implementation);
   if (p_Device) {
     bDevice = 1;
     p_Context = alcCreateContext(p_Device, NULL);
@@ -222,14 +222,14 @@ void adas_Init(ADAS_INIT_DATA * p_adas_d
     if (p_Context) {
       //Set active context
       if (alcMakeContextCurrent(p_Context)) {
-        int bEAXExtPresent = alIsExtensionPresent((ALubyte *) "EAX2.0");
+        int bEAXExtPresent = alIsExtensionPresent("EAX2.0");
 
         if (!bEAXExtPresent) {
           adas_Set_Last_Warning("No EAX2.0 Extension found");
         }
         else {
-          p_EAXSet = (EAXSet) alGetProcAddress((ALubyte *) "EAXSet");
-          p_EAXGet = (EAXGet) alGetProcAddress((ALubyte *) "EAXGet");
+          p_EAXSet = (EAXSet) alGetProcAddress("EAXSet");
+          p_EAXGet = (EAXGet) alGetProcAddress("EAXGet");
 
           if (!p_EAXSet || !p_EAXGet) {
             adas_Set_Last_Error("Cannot find EAXSet and/or EAXGet function");
@@ -370,7 +370,12 @@ unsigned long adas_Load_First(char *p_In
     return 0;
   }
 
-  fgets(data, 100, file);
+  if (fgets(data, 100, file) == NULL) {
+    adas_Set_Last_Error("Unable to read index file");
+    fclose(file);
+    file = NULL;
+    return 0;
+  }
   Size_of_Indexes = atoi(data);
   WaveFile = (ADAS_WAVEFILEDESC *) malloc(Size_of_Indexes * sizeof(ADAS_WAVEFILEDESC));
   if (!WaveFile) {
@@ -381,10 +386,24 @@ unsigned long adas_Load_First(char *p_In
   }
 
   for (i = 0; i < Size_of_Indexes; i++) {
-    fgets(data, 100, file);
+    if (fgets(data, 100, file) == NULL) {
+      adas_Set_Last_Error("Unable to read index file");
+      fclose(file);
+      file = NULL;
+      free(WaveFile);
+      WaveFile = NULL;
+      return 0;
+    }
     newline_cut(data);
     strcpy(WaveFile[i].Name, data);
-    fgets(data, 100, file);
+    if (fgets(data, 100, file) == NULL) {
+      adas_Set_Last_Error("Unable to read index file");
+      fclose(file);
+      file = NULL;
+      free(WaveFile);
+      WaveFile = NULL;
+      return 0;
+    }
     WaveFile[i].Index = atoi(data);
   }
   fclose(file);
@@ -409,13 +428,13 @@ unsigned long adas_Load_First(char *p_In
       return 0;
     }
 
-    alutLoadWAVFile(p_File_Name, &pSound->Format, &pSound->Data,
+    adasLoadWAVFile(p_File_Name, &pSound->Format, &pSound->Data,
                     &pSound->Size, &pSound->Frequece, &loop);
 
     alBufferData(pSound->Buffer, pSound->Format, pSound->Data, pSound->Size,
                  pSound->Frequece);
 
-    alutUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
+    adasUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
                   pSound->Frequece);
 
     pSound->Wave_Index = adas_Translate_Wave(p_File_Name);
@@ -458,7 +477,12 @@ unsigned long adas_Load_FirstMemory(char
   }
 
 
-  fgets(data, 100, file);
+  if (fgets(data, 100, file) == NULL) {
+    adas_Set_Last_Error("Unable to read index file");
+    fclose(file);
+    file = NULL;
+    return 0;
+  }
   Size_of_Indexes = atoi(data);
   WaveFile = (ADAS_WAVEFILEDESC *) malloc(Size_of_Indexes *
                                   sizeof(ADAS_WAVEFILEDESC));
@@ -471,10 +495,24 @@ unsigned long adas_Load_FirstMemory(char
   ZeroMemory(WaveFile, Size_of_Indexes*sizeof(ADAS_WAVEFILEDESC));
 
   for (i = 0; i < Size_of_Indexes; i++) {
-    fgets(data, 100, file);
+    if (fgets(data, 100, file) == NULL) {
+      adas_Set_Last_Error("Unable to read index file");
+      fclose(file);
+      file = NULL;
+      free(WaveFile);
+      WaveFile = NULL;
+      return 0;
+    }
     newline_cut(data);
     strcpy(WaveFile[i].Name, data);
-    fgets(data, 100, file);
+    if (fgets(data, 100, file) == NULL) {
+      adas_Set_Last_Error("Unable to read index file");
+      fclose(file);
+      file = NULL;
+      free(WaveFile);
+      WaveFile = NULL;
+      return 0;
+    }
     WaveFile[i].Index = atoi(data);
   }
   fclose(file);
@@ -498,7 +536,7 @@ unsigned long adas_Load_FirstMemory(char
   if (adasLoadWAVMemory(p_File, File_Size, &pSound->Format, &pSound->Data, &pSound->Size, &pSound->Frequece, &loop)) {
     alBufferData(pSound->Buffer, pSound->Format, pSound->Data, pSound->Size,
                  pSound->Frequece);
-    alutUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
+    adasUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
                   pSound->Frequece);
     pSound->Wave_Index = adas_Translate_Wave(p_File_Name);
     Size_of_Sound_Data++;
@@ -526,7 +564,8 @@ unsigned long adas_Load_Next(char *p_Fil
   if ((Size_of_Sound_Data > SIZEOFSOUNDDATA) || (!p_File_Name))
     return 0;
 
-  chdir(sound_dir);
+  if (chdir(sound_dir))
+    return 0;
   file = fopen(p_File_Name, "r");
   if (file) {
     GetFileSize(file, &Return);
@@ -545,13 +584,13 @@ unsigned long adas_Load_Next(char *p_Fil
       return 0;
     }
 
-    alutLoadWAVFile(p_File_Name, &pSound->Format, &pSound->Data,
+    adasLoadWAVFile(p_File_Name, &pSound->Format, &pSound->Data,
                     &pSound->Size, &pSound->Frequece, &loop);
 
     alBufferData(pSound->Buffer, pSound->Format, pSound->Data, pSound->Size,
                  pSound->Frequece);
 
-    alutUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
+    adasUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
                   pSound->Frequece);
 
     pSound->Wave_Index = adas_Translate_Wave(p_File_Name);
@@ -593,7 +632,7 @@ unsigned long adas_Load_NextMemory(void
   if (adasLoadWAVMemory(p_File, File_Size, &pSound->Format, &pSound->Data, &pSound->Size, &pSound->Frequece, &loop)) {
     alBufferData(pSound->Buffer, pSound->Format, pSound->Data, pSound->Size,
                  pSound->Frequece);
-    alutUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
+    adasUnloadWAV(pSound->Format, pSound->Data, pSound->Size,
                   pSound->Frequece);
     pSound->Wave_Index = adas_Translate_Wave(p_File_Name);
     Size_of_Sound_Data++;
@@ -914,11 +953,12 @@ int adas_Load_Wave(ADAS_SOUND_SOURCE * p
     return 0;
 
   strcpy(text, name);
-  chdir(sound_dir);
-  alutLoadWAVFile(text, &Format, &Data, &Size, &Frequece, &loop);
-  alBufferData(p_ss->Buffer[p_ss->Buffer_Pointer], Format, Data, Size,
+  if (chdir(sound_dir))
+    return 0;
+  adasLoadWAVFile(text, &Format, &Data, &Size, &Frequece, &loop);
+  alBufferData(p_ss->Buffer[(int)p_ss->Buffer_Pointer], Format, Data, Size,
                Frequece);
-  alutUnloadWAV(Format, Data, Size, Frequece);
+  adasUnloadWAV(Format, Data, Size, Frequece);
   return 1;
 }
 
@@ -2569,6 +2609,23 @@ ALCdevice *adas_Get_Device(void)
 }
 
 void *
+adasLoadWAVFile(const char * filename, ALenum * format,
+		void **data, ALsizei * size, ALuint * frequency,
+		ALboolean * loop)
+{
+  ALfloat freq;
+  *data = alutLoadMemoryFromFile(filename, format, size, &freq);
+  if (!(*data)) {
+    fprintf(stderr, "ADAS: adasLoadWAVFile(): %s\n",
+	    alutGetErrorString(alutGetError()));
+    return (FALSE);
+  }
+  *frequency = (ALuint)freq;
+  *loop = AL_FALSE;
+  return (*data);
+}
+
+void *
 adasLoadWAVMemory(ALbyte * buffer, ALsizei buffer_length, ALenum * format,
                   void **data, ALsizei * size, ALuint * frequency,
                   ALboolean * loop)
@@ -2585,6 +2642,12 @@ adasLoadWAVMemory(ALbyte * buffer, ALsiz
   return (*data);
 }
 
+void
+adasUnloadWAV(ALenum format, ALvoid * data, ALsizei size, ALsizei frequency)
+{
+  free(data);
+}
+
 void adas_set_sound_dir(char *p_dir)
 {
   strcpy(sound_dir, p_dir);
Index: berusky2/src/adas/adas.h
===================================================================
--- berusky2.orig/src/adas/adas.h
+++ berusky2/src/adas/adas.h
@@ -317,9 +317,12 @@
 		// get current device
 		ALCdevice *adas_Get_Device(void);
 
-    // Replacement for alutLoadWAVMemory
+    // Replacements for alutLoadWAV{File,Memory} and alutUnloadWAV
+    void * adasLoadWAVFile(const char *filename, ALenum *format, void **data, ALsizei *size,
+			   ALuint *frequency, ALboolean *loop);
     void * adasLoadWAVMemory(ALbyte *buffer, ALsizei buffer_length, ALenum *format, void **data, ALsizei *size,
                           ALuint *frequency, ALboolean *loop);
+    void adasUnloadWAV(ALenum format, ALvoid *data, ALsizei size, ALsizei frequency);
                           
     void adas_set_sound_dir(char *p_dir);
 
Index: berusky2/src/adas/ogg_stream.c
===================================================================
--- berusky2.orig/src/adas/ogg_stream.c
+++ berusky2/src/adas/ogg_stream.c
@@ -6,6 +6,7 @@
 #include <vorbis/vorbisfile.h>
 #include "compat_mini.h"
 
+#include <stdlib.h>
 #include <time.h>
 #include <math.h>
 
@@ -294,7 +295,7 @@ long adas_OGG_Read_StreamB(ADAS_OGG_STRU
 		iCounter++;
 
 		if(p_size_file) {
-			fprintf(p_size_file,"%d\n",lReturn);
+			fprintf(p_size_file,"%ld\n",lReturn);
     }
 
 		switch(lReturn)
@@ -529,7 +530,7 @@ void * adas_OGG_Proc( void *lpParameter
 	int   dwStart, dwFinish, dwEplased;
 	long  losttime = 0;
 	
-	strncpy(text, ogg.Name, (strlen(ogg.Name)-3));
+	strcpy(text, ogg.Name);
 	text[(strlen(ogg.Name)-3)] = '\0'; //TODO - newline?
 	strcat(text,"cyc");
 
@@ -541,10 +542,15 @@ void * adas_OGG_Proc( void *lpParameter
 		ExitThread(0);
 	}
 
-	if(!p_ogg->bSetup)
+	if(!p_ogg->bSetup) {
 		for(i=0;i<3;i++)
 		{
-			fgets(text,256, file);
+			if (fgets(text,256, file) == NULL) {
+				adas_Set_Last_Error("Cannot read file");
+				p_ogg->bEof = 2;
+				fclose(file);
+				ExitThread(0);
+			}
 			cycles = atoi(text);
 			time = (int)floor(750.0f / (float)cycles);
 			adas_OGG_Read_StreamA(p_ogg, time);
@@ -556,9 +562,17 @@ void * adas_OGG_Proc( void *lpParameter
 				ExitThread(0);
 			}
 		}
-	else
-		for(i=0;i<3;i++)
-			fgets(text,256, file);
+	}
+	else {
+		for(i=0;i<3;i++) {
+			if (fgets(text,256, file) == NULL) {
+				adas_Set_Last_Error("Cannot read file");
+				p_ogg->bEof = 2;
+				fclose(file);
+				ExitThread(0);
+			}
+		}
+	}
 
 	alSourceQueueBuffers(p_ogg->Source,3,p_ogg->Buffer);
 	alSourcePlay(p_ogg->Source);
@@ -571,9 +585,14 @@ void * adas_OGG_Proc( void *lpParameter
 		{
 			if (!p_ogg->bEof)
 			{
-				alSourceUnqueueBuffers(p_ogg->Source,1,&p_ogg->Buffer[buffer]);
+				alSourceUnqueueBuffers(p_ogg->Source,1,&p_ogg->Buffer[(int)buffer]);
 				
-				fgets(text,256, file);
+				if (fgets(text,256, file) == NULL) {
+					adas_Set_Last_Error("Cannot read file");
+					p_ogg->bEof = 2;
+					fclose(file);
+					ExitThread(0);
+				}
 				cycles = atoi(text);
 
 				dwStart = timeGetTime();
@@ -589,9 +608,9 @@ void * adas_OGG_Proc( void *lpParameter
 					adas_OGG_Read_StreamA(p_ogg, time);
 				}
 
-				alBufferData(p_ogg->Buffer[buffer], p_ogg->Format, &p_ogg->Data, p_ogg->Size, 
-							       p_ogg->Frequece);
-				alSourceQueueBuffers(p_ogg->Source,1,&p_ogg->Buffer[buffer]);
+				alBufferData(p_ogg->Buffer[(int)buffer],
+					     p_ogg->Format, &p_ogg->Data, p_ogg->Size, p_ogg->Frequece);
+				alSourceQueueBuffers(p_ogg->Source,1,&p_ogg->Buffer[(int)buffer]);
 				
 				dwFinish = timeGetTime();
 				dwEplased = dwFinish - dwStart;
Index: berusky2/src/age/graph/box.cpp
===================================================================
--- berusky2.orig/src/age/graph/box.cpp
+++ berusky2/src/age/graph/box.cpp
@@ -62,9 +62,10 @@ BOX * box_create(BOX_TYPE type, BOX * p_
   bool translate = FALSE;      
   int i;
   for(i = 0; i < num; i++) {
-    if(p_list[i].box_type_get() != type)
+    if(p_list[i].box_type_get() != type) {
       translate = TRUE;
       break;
+    }
   }  
   
   switch(type) {
Index: berusky2/src/age/graph/material_texture.cpp
===================================================================
--- berusky2.orig/src/age/graph/material_texture.cpp
+++ berusky2/src/age/graph/material_texture.cpp
@@ -48,7 +48,8 @@ bool material_text_bitmap_params::load(c
     f.close();
     return(pixmap[0] != '\0');
   } 
-  else {  
+  else {
+    assert(strlen(p_file) < MAX_FILENAME);
     strncpy(pixmap,p_file,MAX_FILENAME);
     pixmap_alpha[0] = '\0'; // No alpha file    
     return(TRUE);  
@@ -593,7 +594,8 @@ void material_text_gl::gl_text_params_de
 bool material_text_gl::gl_text_params_load(char *p_file)
 {  
   char tmp[MAX_FILENAME];
-  
+
+  assert(strlen(p_file) < MAX_FILENAME);
   strncpy(tmp,p_file,MAX_FILENAME);
   tail_change(tmp,TEXTURE_GL_PARAM_FILE);
   
Index: berusky2/src/age/graph/matrix.h
===================================================================
--- berusky2.orig/src/age/graph/matrix.h
+++ berusky2/src/age/graph/matrix.h
@@ -857,7 +857,7 @@ public:
 
 inline GLMATRIX * matrix_zero(GLMATRIX * m)
 {
-  memset(m,0,sizeof(*m));
+  memset((void *)m,0,sizeof(*m));
   return(m);
 } 
 
Index: berusky2/src/age/graph/object_name.h
===================================================================
--- berusky2.orig/src/age/graph/object_name.h
+++ berusky2/src/age/graph/object_name.h
@@ -48,10 +48,13 @@ public:
   
   void name_set(const char *p_name)
   {
-    if(p_name)
+    if(p_name) {
+      assert(strlen(p_name) < MAX_NAME);
       strncpy(name,p_name,MAX_NAME);
-    else
+    }
+    else {
       name[0] = '\0';
+    }
   }
   
   int name_ID_get(void)
Index: berusky2/src/age/graph/surface_sdl.cpp
===================================================================
--- berusky2.orig/src/age/graph/surface_sdl.cpp
+++ berusky2/src/age/graph/surface_sdl.cpp
@@ -337,7 +337,12 @@ void surface_sdl::fill(tcolor color)
 void surface_sdl::fill(tpos x, tpos y, tpos dx, tpos dy, tcolor color)
 { 
   if(p_surf) {
-    SDL_Rect rec = { x, y, dx, dy };
+    SDL_Rect rec;
+    /* Make sure no info will be lost in the conversion to a narrower
+       type. */
+    assert(x < INT16_MAX); assert(y < INT16_MAX);
+    assert(dx < UINT16_MAX); assert(dy < UINT16_MAX);
+    rec = { (Sint16) x, (Sint16) y, (Uint16) dx, (Uint16) dy };
     SDL_FillRect(p_surf, &rec, color);
   }
 }
@@ -346,7 +351,12 @@ void surface_sdl::fill(tpos x, tpos y, t
 void surface_sdl::blit(class surface_sdl *p_dst, tpos tx, tpos ty)
 {
   if(p_surf) {
-    SDL_Rect dst_rec = {tx,ty,p_surf->w,p_surf->h};
+    SDL_Rect dst_rec;
+    /* Make sure no info will be lost in the conversion to a narrower
+       type. */
+    assert(tx < INT16_MAX); assert(ty < INT16_MAX);
+    assert(p_surf->w < UINT16_MAX); assert(p_surf->h < UINT16_MAX);
+    dst_rec = { (Sint16) tx, (Sint16) ty, (Uint16) p_surf->w, (Uint16) p_surf->h};
     SDL_BlitSurface(p_surf, NULL, p_dst->p_surf, &dst_rec);
   }
 }
@@ -355,8 +365,15 @@ void surface_sdl::blit(class surface_sdl
 void surface_sdl::blit(tpos sx, tpos sy, tpos dx, tpos dy, class surface_sdl *p_dst, tpos tx, tpos ty)
 {
   if(p_surf) {
-    SDL_Rect src_rec = {sx,sy,dx,dy};
-    SDL_Rect dst_rec = {tx,ty,dx,dy};
+    SDL_Rect src_rec;
+    SDL_Rect dst_rec;
+    /* Make sure no info will be lost in the conversion to a narrower
+       type. */
+    assert(sx < INT16_MAX); assert(sy < INT16_MAX);
+    assert(tx < INT16_MAX); assert(ty < INT16_MAX);
+    assert(dx < UINT16_MAX); assert(dy < UINT16_MAX);
+    src_rec = { (Sint16) sx, (Sint16) sy, (Uint16) dx, (Uint16) dy };
+    dst_rec = { (Sint16) tx, (Sint16) ty, (Uint16) dx, (Uint16) dy };
     SDL_BlitSurface(p_surf, &src_rec, p_dst->p_surf, &dst_rec);  
   }
 }
Index: berusky2/src/age/graph/vector.h
===================================================================
--- berusky2.orig/src/age/graph/vector.h
+++ berusky2/src/age/graph/vector.h
@@ -169,6 +169,7 @@ typedef struct vect3di
     
   vect3di(void)
   {
+    x = y = z = 0;
   }
   
   vect3di(tpos val)
@@ -214,6 +215,7 @@ typedef struct vect3df
     
   vect3df(void)
   {
+    x = y = z = 0;
   }
   
   vect3df(float val)
Index: berusky2/src/age/utils/data_file.cpp
===================================================================
--- berusky2.orig/src/age/utils/data_file.cpp
+++ berusky2/src/age/utils/data_file.cpp
@@ -163,6 +163,7 @@ bool data_file_section::section_new(int
       source_line_set(line);
     }
     else if(!strcasecmp(token,SECTION_NAME_TYPE)) {
+      assert(strlen(value) < MAX_NAME);
       strncpy(section_type,value,MAX_NAME);
       source_line_set(line);
     }
@@ -434,6 +435,7 @@ void data_file::import(class data_file *
 
 void data_file::source_file_set(const char *p_file)
 {
+  assert(strlen(p_file) < MAX_FILENAME);
   strncpy(current_file_name, p_file, MAX_FILENAME);
 }
 
Index: berusky2/src/age/utils/utils.cpp
===================================================================
--- berusky2.orig/src/age/utils/utils.cpp
+++ berusky2/src/age/utils/utils.cpp
@@ -44,9 +44,11 @@ void dir_list::update_path(char *p_dir)
 {
   char buffer[MAX_FILENAME];
   return_path(p_dir, "", buffer, MAX_FILENAME);
-  chdir(cwd);
-  chdir(buffer);
-  getcwd(p_dir,MAX_FILENAME);
+  /* Separate assertions so the line number in the assertion message
+     will be more helpful. */
+  if (chdir(cwd)) assert(0);
+  if (chdir(buffer)) assert(0);
+  if (getcwd(p_dir,MAX_FILENAME) == NULL) assert(0);
 }
 
 void dir_list::load(char *p_ini)
@@ -63,14 +65,16 @@ void dir_list::load(char *p_ini)
   ini_read_string(p_ini, INI_LEVEL_USER, levels_user, sizeof(levels_user), "./Lihen/User");
   ini_read_string(p_ini, INI_TMP, tmp, sizeof(tmp), "/var/tmp");
 
-  getcwd(cwd,MAX_FILENAME);
+  if (getcwd(cwd,MAX_FILENAME) == NULL)
+    assert(0);
   
   update_path(levels);
   update_path(gamedata);
   update_path(graphics);  
   update_path(levels_user);
   update_path(tmp);
-  chdir(cwd);
+  if (chdir(cwd))
+    assert(0);
 
   #define INI_BINARY      "game_binary"
   ini_read_string(p_ini, INI_BINARY, game_binary, sizeof(game_binary), "berusky");
Index: berusky2/src/kofola/3D_graphic.cpp
===================================================================
--- berusky2.orig/src/kofola/3D_graphic.cpp
+++ berusky2/src/kofola/3D_graphic.cpp
@@ -150,31 +150,43 @@ int _3d_Load_Texture(char *p_File_Name,
 void _3d_Get_Cursor_Name(char *cName)
 {
   FILE *file;
-  char text[MAX_FILENAME];
+  char filename[MAX_FILENAME], text[32];
 
-  GetPrivateProfileString("game", "cursor", "cursor", text, 32, ini_file);
+  GetPrivateProfileString("game", "cursor", "cursor", filename, 32, ini_file);
 
-  strcpy(cName, text);
+  strcpy(cName, filename);
   strcat(cName, ".bmp");
 
-  strcat(text, ".inf");
+  strcat(filename, ".inf");
 
-  file = fopen(text, "r");
+  file = fopen(filename, "r");
   if (!file) {
-    kprintf(1, "Soubor %s, nebyl nalezen!", text);
+    kprintf(1, "Soubor %s, nebyl nalezen!", filename);
     return;
   }
 
-  fgets(text, 32, file);
+  if (fgets(text, 32, file) == NULL) {
+    kprintf(1, "Cannot read from %s!", filename);
+    return;
+  }
   _3dCur.idx = atoi(text);
 
-  fgets(text, 32, file);
+  if (fgets(text, 32, file) == NULL) {
+    kprintf(1, "Cannot read from %s!", filename);
+    return;
+  }
   _3dCur.idy = atoi(text);
 
-  fgets(text, 32, file);
+  if (fgets(text, 32, file) == NULL) {
+    kprintf(1, "Cannot read from %s!", filename);
+    return;
+  }
   _3dCur.iaddx = atoi(text);
 
-  fgets(text, 32, file);
+  if (fgets(text, 32, file) == NULL) {
+    kprintf(1, "Cannot read from %s!", filename);
+    return;
+  }
   _3dCur.iaddy = atoi(text);
 
   fclose(file);
@@ -189,7 +201,10 @@ int _3d_Load_List(char *p_File_Name)
   FILE *file = 0;
   int c = 0;
 
-  chdir((_3dd.bm_dir));
+  if (chdir((_3dd.bm_dir))) {
+    kprintf(1, "Cannot change directory to %s", _3dd.bm_dir);
+    return 0;
+  }
   achdir(p3DMArchive, _3dd.bm_dir);
 
   file = aopen(p3DMArchive, p_File_Name, "rb");
Index: berusky2/src/kofola/Apak.cpp
===================================================================
--- berusky2.orig/src/kofola/Apak.cpp
+++ berusky2/src/kofola/Apak.cpp
@@ -249,6 +249,7 @@ APAK_HANDLE *apakopen(char *cArchive, ch
   int iRet;
   APAK_HANDLE *pHandle;
   FILE *pFile;
+  char tmp_dir[MAX_FILENAME];
 
   apakCheck();
 
@@ -280,7 +281,8 @@ APAK_HANDLE *apakopen(char *cArchive, ch
     return NULL;
   }
 
-  if (!apakLoadFAT(pHandle, apak_dir_correction(cDir)))
+  apak_dir_correction(cDir, tmp_dir);
+  if (!apakLoadFAT(pHandle, tmp_dir))
     apakError(pHandle, "AFAT corrupted");
 
   return pHandle;
@@ -332,14 +334,3 @@ void apak_dir_correction(char *dir, char
     strcpy(out+2, dir);
   }
 }
-
-char * apak_dir_correction(char *dir)
-{
-  static char tmp[MAX_FILENAME] = "c:";
-  if(dir || (tolower(dir[0]) == 'c' && dir[1] == ':'))
-    return(dir);
-  
-  assert(strlen(dir) < 254);
-  strcat(tmp+2, dir);
-  return(tmp);
-}
Index: berusky2/src/kofola/Apak.h
===================================================================
--- berusky2.orig/src/kofola/Apak.h
+++ berusky2/src/kofola/Apak.h
@@ -70,7 +70,6 @@ FILE *afiletoswitch(FILE * stream);
 // testuje zda je textovy soubor v uni code
 int aunicode(FILE * stream);
 
-char * apak_dir_correction(char *dir);
 void apak_dir_correction(char *dir, char *out);
 
 #endif
Index: berusky2/src/kofola/Apakio.cpp
===================================================================
--- berusky2.orig/src/kofola/Apakio.cpp
+++ berusky2/src/kofola/Apakio.cpp
@@ -61,7 +61,10 @@ int fillbuffer(APAK_FILE_HANDLE * pFHand
   pTmp = (char *) mmalloc(size);
 
   fseek(pFHandle->pArchive->pFILE, pFHandle->apuLfStartofFile, SEEK_SET);
-  fread(pTmp, size, 1, pFHandle->pArchive->pFILE);
+  if (fread(pTmp, size, 1, pFHandle->pArchive->pFILE) != 1) {
+    free((void *) pTmp);
+    return 0;
+  }
 
   if (pFHandle->pFileInfo->bNotCompressed)
     memcpy(pFHandle->pBuffer, pTmp, size);
Index: berusky2/src/kofola/Comics.cpp
===================================================================
--- berusky2.orig/src/kofola/Comics.cpp
+++ berusky2/src/kofola/Comics.cpp
@@ -97,7 +97,8 @@ void cmcs_Start_Comics(char *cFile, HWND
     cmcs_Picture[i].iPicture = -1;
 
   while (strcmp(text, "LOAD_END")) {
-    fgets(text, MAX_FILENAME, file);
+    if (fgets(text, MAX_FILENAME, file) == NULL)
+      return;
     newline_cut(text);
 
     if (!strcmp(text, "LOAD_END"))
@@ -109,7 +110,8 @@ void cmcs_Start_Comics(char *cFile, HWND
   i = 0;
 
   while (strcmp(text, "COMICS_END")) {
-    fgets(text, MAX_FILENAME, file);
+    if (fgets(text, MAX_FILENAME, file) == NULL)
+      return;
     newline_cut(text);
     cmcs_Read_Line(text, &cmcs_Picture[i]);
     cmcs_Picture[i].iPicture = i + 1;
@@ -154,7 +156,8 @@ void cmcs_Start_Comics(char *cFile, HWND
 
 void cmcs_Play_Intro(char *cFile, HWND hWnd, AUDIO_DATA * p_ad)
 {
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR))
+    return;
   cmcs_Start_Comics("gamelogo.txt", hWnd, p_ad, 0);
 }
 
Index: berusky2/src/kofola/Demo.cpp
===================================================================
--- berusky2.orig/src/kofola/Demo.cpp
+++ berusky2/src/kofola/Demo.cpp
@@ -22,24 +22,35 @@ void demo_Set_Scene_Level(char *cDemo, i
   FILE *file;
   DEMOFILEHEADER FileHeader;
 
-  getcwd(odir, MAX_FILENAME);
+  if (getcwd(odir, MAX_FILENAME) == NULL)
+    return;
 
-  chdir(SAVE_DIR);
+  if (chdir(SAVE_DIR))
+    return;
 
   file = fopen(cDemo, "rb");
 
   if (!file) {
-    chdir((odir));
+    /* GCC warns when we don't check the return value of chdir(). For
+       some reason, casting to (void) doesn't work. */
+    if (chdir(odir))
+      return;
     return;
   }
 
-  fread(&FileHeader, sizeof(DEMOFILEHEADER), 1, file);
+  if (fread(&FileHeader, sizeof(DEMOFILEHEADER), 1, file) != 1) {
+    fclose(file);
+    return;
+  }
   fclose(file);
 
   (*pScene) = FileHeader.iScene;
   (*pLevel) = FileHeader.iLevel;
 
-  chdir((odir));
+  /* GCC warns when we don't check the return value of chdir(). For
+     some reason, casting to (void) doesn't work. */
+  if (chdir(odir))
+    return;
 }
 
 int demo_Check_Owner(WCHAR * wPlayer, char *cDemo, WCHAR * wDemoName)
@@ -258,7 +269,8 @@ int demo_SaveWC(DEMOSTRUCTURE * p_Demo,
 
   sprintf(cFile, "demo_[%s]_[%s].dem", pom, pom2);
 
-  chdir(SAVE_DIR);
+  if (chdir(SAVE_DIR))
+    return 0;
 
   //strcat(cText, DIR_SLASH_STRING);
   //strcat(cText, cFile);
@@ -323,7 +335,11 @@ int demo_Load(DEMOSTRUCTURE * p_Demo, ch
     return 0;
   }
 
-  fread(&FileHeader, sizeof(DEMOFILEHEADER), 1, file);
+  if (fread(&FileHeader, sizeof(DEMOFILEHEADER), 1, file) != 1) {
+    kprintf(1, "Cannot read %s", p_File_Name);
+    fclose(file);
+    return 0;
+  }
 
   if (FileHeader.iDemoID != 123456789 ||
     FileHeader.iHiVer != DEMO_HIVERSION ||
@@ -342,7 +358,11 @@ int demo_Load(DEMOSTRUCTURE * p_Demo, ch
   if (FileHeader.iLoadedLevel)
     strcpy(cLoadedSignature, "LOAD_GAME");
 
-  fread(p_Demo, sizeof(DEMOSTRUCTURE), 1, file);
+  if (fread(p_Demo, sizeof(DEMOSTRUCTURE), 1, file) != 1) {
+    kprintf(1, "Cannot read %s", p_File_Name);
+    fclose(file);
+    return 0;
+  }
 
   p_Frame = (DEMOKEYFRAME *) mmalloc(sizeof(DEMOKEYFRAME));
 
@@ -354,7 +374,14 @@ int demo_Load(DEMOSTRUCTURE * p_Demo, ch
   for (i = 0; i < p_Demo->Frame_Counter - 1; i++) {
     p_Frame = (DEMOKEYFRAME *) mmalloc(sizeof(DEMOKEYFRAME));
 
-    fread(p_Frame, sizeof(DEMOKEYFRAME), 1, file);
+    if (fread(p_Frame, sizeof(DEMOKEYFRAME), 1, file) != 0) {
+      kprintf(1, "Cannot read %s", p_File_Name);
+      fclose(file);
+      demo_Release(p_Demo);
+      free(p_Frame);
+      return 0;
+    }
+
     p_Last->p_Next = p_Frame;
 
     p_Last = p_Frame;
Index: berusky2/src/kofola/Init.cpp
===================================================================
--- berusky2.orig/src/kofola/Init.cpp
+++ berusky2/src/kofola/Init.cpp
@@ -24,9 +24,11 @@ int lsi_Load_Items(LEVELINFO * p_Level)
   SECONDDATADESC sec;
   APAK_HANDLE *aHandle;
   
-  getcwd(odir, MAX_FILENAME);
+  if (getcwd(odir, MAX_FILENAME) == NULL)
+    return 0;
   strcpy(dir, PRVKY_DIR);
-  chdir(dir);
+  if (chdir(dir))
+    return 0;
 
   strcpy(text, "*.itm");
   Count = 0;
@@ -82,10 +84,11 @@ int lsi_Load_Items(LEVELINFO * p_Level)
 
   afindclose(Done);
 
-  chdir((odir));
-
   apakclose(&aHandle);
 
+  if (chdir(odir))
+    return 0;
+
   return 1;
 }
 
